# **********************************************************************
# Copyright (c) 2022 Institute of Software, Chinese Academy of Sciences.
# kconfigDepDetector is licensed under Mulan PSL v2.
# You can use this software according to the terms and conditions of the Mulan PSL v2.
# You may obtain a copy of Mulan PSL v2 at:
#         http://license.coscl.org.cn/MulanPSL2
# THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND, 
# EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT, MERCHANTABILITY
# OR FIT FOR A PARTICULAR PURPOSE.
# See the Mulan PSL v2 for more details.
# **********************************************************************/
# parsetab.py
# This file is automatically generated. Do not edit.
_tabversion = '3.10'

_lr_method = 'LALR'

_lr_signature = 'leftORleftANDleftNOTleftOPEN_PARENTCLOSE_PARENTleftGREATER_EQUALleftLESS_EQUALleftGREATERleftLESSleftUNEQUALleftEQUALWORD QUOTE_WORD SP_WORD OR AND EQUAL UNEQUAL LESS LESS_EQUAL GREATER GREATER_EQUAL NOT OPEN_PARENT CLOSE_PARENT EOL HELP HELP_CONTEXT MAINMENU MENUCONFIG MENU ENDMENU IF ENDIF BOOL TRISTATE INT HEX STRING CHOICE ENDCHOICE DEPENDS ON SELECT DEFAULT IMPLY RANGE VISIBILE MODULES SOURCE CONFIG COMMENT DEF_BOOL DEF_TRISTATE OPTIONAL PROMPT PATH ENDPATH\n    input : input mainmenu_stmt\n        | input config_stmt\n        | input menu_stmt\n        | input if_stmt\n        | input choice_stmt\n        | input groupend_stmt\n        | input comment_stmt\n        | input source_stmt\n        | input type_stmt\n        | input depends_stmt\n        | input select_imply_stmt\n        | input prompt_stmt\n        | input default_stmt\n        | input help_stmt\n        | input range_stmt\n        | input visible_stmt\n        | input modules_stmt\n        | input optional_stmt\n\n        | input path_stmt\n        | input endpath_stmt\n\n        | empty\n    \n    path_stmt : PATH QUOTE_WORD EOL\n    \n    endpath_stmt : ENDPATH EOL\n    \n    mainmenu_stmt : MAINMENU QUOTE_WORD EOL\n    \n    config_stmt : CONFIG WORD EOL\n                | MENUCONFIG WORD EOL\n    \n    comment_stmt : COMMENT QUOTE_WORD EOL\n    \n    menu_stmt : MENU QUOTE_WORD EOL\n    \n    if_stmt : IF expr EOL\n    \n    choice_stmt : CHOICE WORD EOL\n                | CHOICE EOL\n    \n    groupend_stmt : ENDMENU EOL\n                | ENDIF EOL\n                | ENDCHOICE EOL\n    \n    prompt_stmt_opt : QUOTE_WORD if_expr\n                    | empty\n    \n    type_stmt : INT prompt_stmt_opt EOL\n            | HEX prompt_stmt_opt EOL\n            | STRING prompt_stmt_opt EOL\n            | BOOL prompt_stmt_opt EOL\n            | TRISTATE prompt_stmt_opt EOL\n    \n    prompt_stmt : PROMPT QUOTE_WORD if_expr EOL\n    \n    help_stmt : HELP HELP_CONTEXT EOL\n            | HELP HELP_CONTEXT\n    \n    depends_stmt : DEPENDS ON expr EOL\n    \n    select_imply_stmt : SELECT QUOTE_WORD if_expr EOL\n                    | SELECT WORD if_expr EOL\n                    |  IMPLY WORD if_expr EOL\n    \n    range_stmt : RANGE symbol symbol if_expr EOL\n    \n    optional_stmt : OPTIONAL EOL\n    \n    default_stmt : DEFAULT expr if_expr EOL\n                | DEF_BOOL expr if_expr EOL\n                | DEF_TRISTATE expr if_expr EOL\n    \n    visible_stmt : VISIBILE if_expr EOL\n    \n    modules_stmt : MODULES EOL\n    \n    source_stmt : SOURCE QUOTE_WORD EOL\n    \n    symbol : WORD \n        | QUOTE_WORD\n        | SP_WORD\n    \n    if_expr : IF expr\n            | empty\n    \n    expr : symbol\n\t    | symbol LESS symbol\n\t    | symbol LESS_EQUAL symbol\n\t    | symbol GREATER symbol\n\t    | symbol GREATER_EQUAL symbol\n\t    | symbol EQUAL symbol\n\t    | symbol UNEQUAL symbol\n\n        | NOT expr\n\t    | OPEN_PARENT expr CLOSE_PARENT\n        | expr OR expr\n\t    | expr AND expr\n    empty :'
    
_lr_action_items = {'MAINMENU':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,23,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'CONFIG':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,24,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'MENUCONFIG':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,25,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'MENU':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,26,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'IF':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,48,58,61,62,63,65,66,67,68,72,79,80,81,82,83,84,85,86,91,92,94,95,96,97,98,99,108,110,111,112,113,115,116,117,118,127,128,129,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,150,],[-73,27,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,89,-62,-57,-58,-59,-31,-32,-33,-34,89,89,89,89,89,89,89,89,-44,-55,-50,-23,-24,-25,-26,-28,-29,-69,-30,-27,-56,-37,-38,-39,-40,-41,-43,89,-54,-22,-71,-72,-63,-64,-65,-66,-67,-68,-70,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'CHOICE':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,28,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'ENDMENU':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,29,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'ENDIF':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,30,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'ENDCHOICE':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,31,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'COMMENT':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,32,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'SOURCE':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,33,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'INT':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,34,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'HEX':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,35,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'STRING':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,36,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'BOOL':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,37,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'TRISTATE':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,38,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'DEPENDS':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,39,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'SELECT':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,40,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'IMPLY':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,41,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'PROMPT':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,42,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'DEFAULT':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,43,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'DEF_BOOL':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,44,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'DEF_TRISTATE':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,45,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'HELP':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,46,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'RANGE':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,47,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'VISIBILE':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,48,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'MODULES':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,49,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'OPTIONAL':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,50,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'PATH':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,51,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'ENDPATH':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,52,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'$end':([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,65,66,67,68,86,91,92,94,95,96,97,98,99,110,111,112,113,115,116,117,118,127,129,131,141,142,143,144,145,146,147,148,150,],[-73,0,-21,-1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20,-31,-32,-33,-34,-44,-55,-50,-23,-24,-25,-26,-28,-29,-30,-27,-56,-37,-38,-39,-40,-41,-43,-54,-22,-45,-46,-47,-48,-42,-51,-52,-53,-49,]),'QUOTE_WORD':([23,26,27,32,33,34,35,36,37,38,40,42,43,44,45,47,51,59,60,61,62,63,78,87,89,100,101,102,103,104,105,106,107,],[53,56,62,69,70,72,72,72,72,72,79,82,62,62,62,62,93,62,62,-57,-58,-59,62,62,62,62,62,62,62,62,62,62,62,]),'WORD':([24,25,27,28,40,41,43,44,45,47,59,60,61,62,63,78,87,89,100,101,102,103,104,105,106,107,],[54,55,61,64,80,81,61,61,61,61,61,61,-57,-58,-59,61,61,61,61,61,61,61,61,61,61,61,]),'NOT':([27,43,44,45,59,60,78,89,100,101,],[59,59,59,59,59,59,59,59,59,59,]),'OPEN_PARENT':([27,43,44,45,59,60,78,89,100,101,],[60,60,60,60,60,60,60,60,60,60,]),'SP_WORD':([27,43,44,45,47,59,60,61,62,63,78,87,89,100,101,102,103,104,105,106,107,],[63,63,63,63,63,63,63,-57,-58,-59,63,63,63,63,63,63,63,63,63,63,63,]),'EOL':([28,29,30,31,34,35,36,37,38,48,49,50,52,53,54,55,56,57,58,61,62,63,64,69,70,71,72,73,74,75,76,77,79,80,81,82,83,84,85,86,88,90,93,108,114,119,120,121,122,123,124,125,126,128,130,132,133,134,135,136,137,138,139,140,149,],[65,66,67,68,-73,-73,-73,-73,-73,-73,91,92,94,95,96,97,98,99,-62,-57,-58,-59,110,111,112,113,-73,-36,115,116,117,118,-73,-73,-73,-73,-73,-73,-73,127,129,-61,131,-69,-35,141,142,143,144,145,146,147,148,-73,-60,-71,-72,-63,-64,-65,-66,-67,-68,-70,150,]),'ON':([39,],[78,]),'HELP_CONTEXT':([46,],[86,]),'OR':([57,58,61,62,63,83,84,85,108,109,119,130,132,133,134,135,136,137,138,139,140,],[100,-62,-57,-58,-59,100,100,100,-69,100,100,100,-71,-72,-63,-64,-65,-66,-67,-68,-70,]),'AND':([57,58,61,62,63,83,84,85,108,109,119,130,132,133,134,135,136,137,138,139,140,],[101,-62,-57,-58,-59,101,101,101,-69,101,101,101,101,-72,-63,-64,-65,-66,-67,-68,-70,]),'CLOSE_PARENT':([58,61,62,63,108,109,132,133,134,135,136,137,138,139,140,],[-62,-57,-58,-59,-69,140,-71,-72,-63,-64,-65,-66,-67,-68,-70,]),'LESS':([58,61,62,63,],[102,-57,-58,-59,]),'LESS_EQUAL':([58,61,62,63,],[103,-57,-58,-59,]),'GREATER':([58,61,62,63,],[104,-57,-58,-59,]),'GREATER_EQUAL':([58,61,62,63,],[105,-57,-58,-59,]),'EQUAL':([58,61,62,63,],[106,-57,-58,-59,]),'UNEQUAL':([58,61,62,63,],[107,-57,-58,-59,]),}

_lr_action = {}
for _k, _v in _lr_action_items.items():
   for _x,_y in zip(_v[0],_v[1]):
      if not _x in _lr_action:  _lr_action[_x] = {}
      _lr_action[_x][_k] = _y
del _lr_action_items

_lr_goto_items = {'input':([0,],[1,]),'empty':([0,34,35,36,37,38,48,72,79,80,81,82,83,84,85,128,],[2,73,73,73,73,73,90,90,90,90,90,90,90,90,90,90,]),'mainmenu_stmt':([1,],[3,]),'config_stmt':([1,],[4,]),'menu_stmt':([1,],[5,]),'if_stmt':([1,],[6,]),'choice_stmt':([1,],[7,]),'groupend_stmt':([1,],[8,]),'comment_stmt':([1,],[9,]),'source_stmt':([1,],[10,]),'type_stmt':([1,],[11,]),'depends_stmt':([1,],[12,]),'select_imply_stmt':([1,],[13,]),'prompt_stmt':([1,],[14,]),'default_stmt':([1,],[15,]),'help_stmt':([1,],[16,]),'range_stmt':([1,],[17,]),'visible_stmt':([1,],[18,]),'modules_stmt':([1,],[19,]),'optional_stmt':([1,],[20,]),'path_stmt':([1,],[21,]),'endpath_stmt':([1,],[22,]),'expr':([27,43,44,45,59,60,78,89,100,101,],[57,83,84,85,108,109,119,130,132,133,]),'symbol':([27,43,44,45,47,59,60,78,87,89,100,101,102,103,104,105,106,107,],[58,58,58,58,87,58,58,58,128,58,58,58,134,135,136,137,138,139,]),'prompt_stmt_opt':([34,35,36,37,38,],[71,74,75,76,77,]),'if_expr':([48,72,79,80,81,82,83,84,85,128,],[88,114,120,121,122,123,124,125,126,149,]),}

_lr_goto = {}
for _k, _v in _lr_goto_items.items():
   for _x, _y in zip(_v[0], _v[1]):
       if not _x in _lr_goto: _lr_goto[_x] = {}
       _lr_goto[_x][_k] = _y
del _lr_goto_items
_lr_productions = [
  ("S' -> input","S'",1,None,None,None),
  ('input -> input mainmenu_stmt','input',2,'p_input','config_yacc.py',210),
  ('input -> input config_stmt','input',2,'p_input','config_yacc.py',211),
  ('input -> input menu_stmt','input',2,'p_input','config_yacc.py',212),
  ('input -> input if_stmt','input',2,'p_input','config_yacc.py',213),
  ('input -> input choice_stmt','input',2,'p_input','config_yacc.py',214),
  ('input -> input groupend_stmt','input',2,'p_input','config_yacc.py',215),
  ('input -> input comment_stmt','input',2,'p_input','config_yacc.py',216),
  ('input -> input source_stmt','input',2,'p_input','config_yacc.py',217),
  ('input -> input type_stmt','input',2,'p_input','config_yacc.py',218),
  ('input -> input depends_stmt','input',2,'p_input','config_yacc.py',219),
  ('input -> input select_imply_stmt','input',2,'p_input','config_yacc.py',220),
  ('input -> input prompt_stmt','input',2,'p_input','config_yacc.py',221),
  ('input -> input default_stmt','input',2,'p_input','config_yacc.py',222),
  ('input -> input help_stmt','input',2,'p_input','config_yacc.py',223),
  ('input -> input range_stmt','input',2,'p_input','config_yacc.py',224),
  ('input -> input visible_stmt','input',2,'p_input','config_yacc.py',225),
  ('input -> input modules_stmt','input',2,'p_input','config_yacc.py',226),
  ('input -> input optional_stmt','input',2,'p_input','config_yacc.py',227),
  ('input -> input path_stmt','input',2,'p_input','config_yacc.py',229),
  ('input -> input endpath_stmt','input',2,'p_input','config_yacc.py',230),
  ('input -> empty','input',1,'p_input','config_yacc.py',232),
  ('path_stmt -> PATH QUOTE_WORD EOL','path_stmt',3,'p_path_stmt','config_yacc.py',240),
  ('endpath_stmt -> ENDPATH EOL','endpath_stmt',2,'p_endpath_stmt','config_yacc.py',250),
  ('mainmenu_stmt -> MAINMENU QUOTE_WORD EOL','mainmenu_stmt',3,'p_mainmenu_stmt','config_yacc.py',262),
  ('config_stmt -> CONFIG WORD EOL','config_stmt',3,'p_config_stmt','config_yacc.py',278),
  ('config_stmt -> MENUCONFIG WORD EOL','config_stmt',3,'p_config_stmt','config_yacc.py',279),
  ('comment_stmt -> COMMENT QUOTE_WORD EOL','comment_stmt',3,'p_comment','config_yacc.py',308),
  ('menu_stmt -> MENU QUOTE_WORD EOL','menu_stmt',3,'p_menu','config_yacc.py',323),
  ('if_stmt -> IF expr EOL','if_stmt',3,'p_if','config_yacc.py',339),
  ('choice_stmt -> CHOICE WORD EOL','choice_stmt',3,'p_choice','config_yacc.py',359),
  ('choice_stmt -> CHOICE EOL','choice_stmt',2,'p_choice','config_yacc.py',360),
  ('groupend_stmt -> ENDMENU EOL','groupend_stmt',2,'p_groupend_stmt','config_yacc.py',382),
  ('groupend_stmt -> ENDIF EOL','groupend_stmt',2,'p_groupend_stmt','config_yacc.py',383),
  ('groupend_stmt -> ENDCHOICE EOL','groupend_stmt',2,'p_groupend_stmt','config_yacc.py',384),
  ('prompt_stmt_opt -> QUOTE_WORD if_expr','prompt_stmt_opt',2,'p_type_option','config_yacc.py',425),
  ('prompt_stmt_opt -> empty','prompt_stmt_opt',1,'p_type_option','config_yacc.py',426),
  ('type_stmt -> INT prompt_stmt_opt EOL','type_stmt',3,'p_type_stmt','config_yacc.py',451),
  ('type_stmt -> HEX prompt_stmt_opt EOL','type_stmt',3,'p_type_stmt','config_yacc.py',452),
  ('type_stmt -> STRING prompt_stmt_opt EOL','type_stmt',3,'p_type_stmt','config_yacc.py',453),
  ('type_stmt -> BOOL prompt_stmt_opt EOL','type_stmt',3,'p_type_stmt','config_yacc.py',454),
  ('type_stmt -> TRISTATE prompt_stmt_opt EOL','type_stmt',3,'p_type_stmt','config_yacc.py',455),
  ('prompt_stmt -> PROMPT QUOTE_WORD if_expr EOL','prompt_stmt',4,'p_prompt_stmt','config_yacc.py',476),
  ('help_stmt -> HELP HELP_CONTEXT EOL','help_stmt',3,'p_help_stmt','config_yacc.py',500),
  ('help_stmt -> HELP HELP_CONTEXT','help_stmt',2,'p_help_stmt','config_yacc.py',501),
  ('depends_stmt -> DEPENDS ON expr EOL','depends_stmt',4,'p_depends_stmt','config_yacc.py',512),
  ('select_imply_stmt -> SELECT QUOTE_WORD if_expr EOL','select_imply_stmt',4,'p_select_imply_stmt','config_yacc.py',533),
  ('select_imply_stmt -> SELECT WORD if_expr EOL','select_imply_stmt',4,'p_select_imply_stmt','config_yacc.py',534),
  ('select_imply_stmt -> IMPLY WORD if_expr EOL','select_imply_stmt',4,'p_select_imply_stmt','config_yacc.py',535),
  ('range_stmt -> RANGE symbol symbol if_expr EOL','range_stmt',5,'p_range_stmt','config_yacc.py',574),
  ('optional_stmt -> OPTIONAL EOL','optional_stmt',2,'p_optional','config_yacc.py',594),
  ('default_stmt -> DEFAULT expr if_expr EOL','default_stmt',4,'p_default_stmt','config_yacc.py',603),
  ('default_stmt -> DEF_BOOL expr if_expr EOL','default_stmt',4,'p_default_stmt','config_yacc.py',604),
  ('default_stmt -> DEF_TRISTATE expr if_expr EOL','default_stmt',4,'p_default_stmt','config_yacc.py',605),
  ('visible_stmt -> VISIBILE if_expr EOL','visible_stmt',3,'p_visible_stmt','config_yacc.py',637),
  ('modules_stmt -> MODULES EOL','modules_stmt',2,'p_modules_stmt','config_yacc.py',653),
  ('source_stmt -> SOURCE QUOTE_WORD EOL','source_stmt',3,'p_source','config_yacc.py',662),
  ('symbol -> WORD','symbol',1,'p_symbol','config_yacc.py',672),
  ('symbol -> QUOTE_WORD','symbol',1,'p_symbol','config_yacc.py',673),
  ('symbol -> SP_WORD','symbol',1,'p_symbol','config_yacc.py',674),
  ('if_expr -> IF expr','if_expr',2,'p_if_expr','config_yacc.py',698),
  ('if_expr -> empty','if_expr',1,'p_if_expr','config_yacc.py',699),
  ('expr -> symbol','expr',1,'p_expr','config_yacc.py',719),
  ('expr -> symbol LESS symbol','expr',3,'p_expr','config_yacc.py',720),
  ('expr -> symbol LESS_EQUAL symbol','expr',3,'p_expr','config_yacc.py',721),
  ('expr -> symbol GREATER symbol','expr',3,'p_expr','config_yacc.py',722),
  ('expr -> symbol GREATER_EQUAL symbol','expr',3,'p_expr','config_yacc.py',723),
  ('expr -> symbol EQUAL symbol','expr',3,'p_expr','config_yacc.py',724),
  ('expr -> symbol UNEQUAL symbol','expr',3,'p_expr','config_yacc.py',725),
  ('expr -> NOT expr','expr',2,'p_expr','config_yacc.py',727),
  ('expr -> OPEN_PARENT expr CLOSE_PARENT','expr',3,'p_expr','config_yacc.py',728),
  ('expr -> expr OR expr','expr',3,'p_expr','config_yacc.py',729),
  ('expr -> expr AND expr','expr',3,'p_expr','config_yacc.py',730),
  ('empty -> <empty>','empty',0,'p_empty','config_yacc.py',779),
]
